"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ParticipantInjectCancer(ProtocolElement):
    """
    Record for tiered variant injection as part of the data intake for CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "participant",
        "reportModelVersion",
        "version",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import participant as participant_1_1_0

        return {
            "participant": participant_1_1_0.CancerParticipant,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0
        from protocols.protocol_6_1 import participant as participant_1_1_0

        return {
            "org.gel.models.participant.avro.CancerParticipant": participant_1_1_0.CancerParticipant,
            "org.gel.models.cva.avro.ParticipantInjectCancer": cva_1_0_0.ParticipantInjectCancer,
        }

    __slots__ = [
        "id",
        "participant",
        "reportModelVersion",
        "version",
    ]

    def __init__(
        self,
        id,
        participant,
        reportModelVersion,
        version,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_0_0.ParticipantInjectCancer model.

        :param id:
            The identifier for the entity containing this reported variant.
        :type id: str
        :param participant:
            The information on the cancer participant
        :type participant: CancerParticipant
        :param reportModelVersion:
            Report avro models version
        :type reportModelVersion: str
        :param version:
            The version for the entity containing this reported variant. This is a
            correlative number being the highest         value the
            latest version.
        :type version: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
